use strict;

use DE_EPAGES::Core::API::Script qw ( RunScript );
use Test::More;
use DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver;
use DE_EPAGES::GoogleBase::t::MockingExporterObject;
use DE_EPAGES::GoogleBase::t::MockProduct;
sub Main {
    testitem_group_id();
    testsize();
    testcolor();
    testage_group();
    testgender();
    testmaterial();
    testpattern();
    done_testing();
}

sub testitem_group_id {
    note ('--------------------------------------------------');
    note('test Item_group_id');
    note ('--------------------------------------------------');
      my $False = '';
      my $Answer = 'TestResponse';
      my $Product = DE_EPAGES::GoogleBase::t::MockProduct->new();
      my $TestExporterObject = DE_EPAGES::GoogleBase::t::MockingExporterObject->new();
      $Product->setValue('Alias',$Answer);
      $Product->setValue( 'getWithParent', $Product);
      $TestExporterObject->SetLocale('de_DE');
      is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::item_group_id($TestExporterObject,$Product),$Answer,'correct with de_DE');
      $TestExporterObject->SetLocale('en_US');
      is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::item_group_id($TestExporterObject,$Product),$Answer,'correct with en_US');
      $TestExporterObject->SetLocale('en_GB');
      is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::item_group_id($TestExporterObject,$Product),$Answer,'correct with en_GB');
      $TestExporterObject->SetLocale('fr_FR');
      is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::item_group_id($TestExporterObject,$Product),$Answer,'correct with fr_FR');
      $TestExporterObject->SetLocale('xx_XX');
      is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::item_group_id($TestExporterObject,$Product),$False,'correct with xx_XX');
}

sub testsize{
    note ('--------------------------------------------------');
    note('test size');
    note ('--------------------------------------------------');
    # init
    my $False = '';
    my $Answer = 'TestResponse';
    my $Product = DE_EPAGES::GoogleBase::t::MockProduct->new();
    my $TestExporterObject = DE_EPAGES::GoogleBase::t::MockingExporterObject->new();
    $Product->setValue('Class',$Product);
    $Product->setValue('Alias',$Answer);
    # tests
    $TestExporterObject->SetLocale('en_US');
    $Product->setValue( 'getWithParent', $Product);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::size($TestExporterObject,$Product),$Answer,'correct with en_US');
    $TestExporterObject->SetLocale('de_DE');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::size($TestExporterObject,$Product),$Answer,'correct with de_DE');
    $TestExporterObject->SetLocale('en_GB');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::size($TestExporterObject,$Product),$Answer,'correct with en_GB');
    $TestExporterObject->SetLocale('fr_FR');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::size($TestExporterObject,$Product),$Answer,'correct with fr_FR');
    $TestExporterObject->SetLocale('xx_XX');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::size($TestExporterObject,$Product),$False,'correct with xx_XX');
}

sub testcolor{
    note ('--------------------------------------------------');
    note('test color');
    note ('--------------------------------------------------');
    # init
    my $False = '';
    my $Answer = 'TestResponse';
    my $Product = DE_EPAGES::GoogleBase::t::MockProduct->new();
    my $TestExporterObject = DE_EPAGES::GoogleBase::t::MockingExporterObject->new();
    $Product->setValue('Class',$Product);
    $Product->setValue('Alias',$Answer);
    # tests
    $TestExporterObject->SetLocale('en_US');
    $Product->setValue( 'getWithParent', $Product);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::color($TestExporterObject,$Product),$Answer,'correct with en_US');
    $TestExporterObject->SetLocale('de_DE');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::color($TestExporterObject,$Product),$Answer,'correct with de_DE');
    $TestExporterObject->SetLocale('en_GB');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::color($TestExporterObject,$Product),$Answer,'correct with en_GB');
    $TestExporterObject->SetLocale('fr_FR');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::color($TestExporterObject,$Product),$Answer,'correct with fr_FR');
    $TestExporterObject->SetLocale('xx_XX');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::color($TestExporterObject,$Product),$False,'correct with xx_XX');
}

sub testage_group{
    note ('--------------------------------------------------');
    note('test age_group');
    note ('--------------------------------------------------');
    # init
    my $False = '';
    my $Answer = 'TestResponse';
    my $Product = DE_EPAGES::GoogleBase::t::MockProduct->new();
    my $TestExporterObject = DE_EPAGES::GoogleBase::t::MockingExporterObject->new();
    $Product->setValue('Class',$Product);
    $Product->setValue('Alias',$Answer);
    # tests
    $TestExporterObject->SetLocale('en_US');
    $Product->setValue( 'getWithParent', $Product);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::age_group($TestExporterObject,$Product),$Answer,'correct with en_US');
    $TestExporterObject->SetLocale('de_DE');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::age_group($TestExporterObject,$Product),$Answer,'correct with de_DE');
    $TestExporterObject->SetLocale('en_GB');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::age_group($TestExporterObject,$Product),$Answer,'correct with en_GB');
    $TestExporterObject->SetLocale('fr_FR');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::age_group($TestExporterObject,$Product),$Answer,'correct with fr_FR');
    $TestExporterObject->SetLocale('xx_XX');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::age_group($TestExporterObject,$Product),$False,'correct with xx_XX');
}
sub testgender{
    note ('--------------------------------------------------');
    note('test gender');
    note ('--------------------------------------------------');
    # init
    my $False = '';
    my $Answer = 'TestResponse';
    my $Product = DE_EPAGES::GoogleBase::t::MockProduct->new();
    my $TestExporterObject = DE_EPAGES::GoogleBase::t::MockingExporterObject->new();
    $Product->setValue('Class',$Product);
    $Product->setValue('Alias',$Answer);
    # tests
    $TestExporterObject->SetLocale('en_US');
    $Product->setValue( 'getWithParent', $Product);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::gender($TestExporterObject,$Product),$Answer,'correct with en_US');
    $TestExporterObject->SetLocale('de_DE');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::gender($TestExporterObject,$Product),$Answer,'correct with de_DE');
    $TestExporterObject->SetLocale('en_GB');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::gender($TestExporterObject,$Product),$Answer,'correct with en_GB');
    $TestExporterObject->SetLocale('fr_FR');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::gender($TestExporterObject,$Product),$Answer,'correct with fr_FR');
    $TestExporterObject->SetLocale('xx_XX');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::gender($TestExporterObject,$Product),$False,'correct with xx_XX');
}
sub testmaterial{
    note ('--------------------------------------------------');
    note('test material');
    note ('--------------------------------------------------');
    # init
    my $False = '';
    my $Answer = 'TestResponse';
    my $Product = DE_EPAGES::GoogleBase::t::MockProduct->new();
    my $TestExporterObject = DE_EPAGES::GoogleBase::t::MockingExporterObject->new();
    $Product->setValue('Class',$Product);
    $Product->setValue('Alias',$Answer);

        # tests
    $TestExporterObject->SetLocale('en_US');
    $Product->setValue( 'getWithParent', $Product);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product),$Answer,'correct with en_US');
    $Product->setValue( 'getWithParent', []);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product),$False,'correct with en_US');
    $Product->setValue( 'getWithParent', 'IAmNotBessedAndNotAnArray');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product)
        ,'IAmNotBessedAndNotAnArray'
        ,'correct with en_US');

    $TestExporterObject->SetLocale('de_DE');
    $Product->setValue( 'getWithParent', $Product);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product),$Answer,'correct with de_DE');
    $Product->setValue( 'getWithParent', []);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product),$False,'correct with de_DE');
    $Product->setValue( 'getWithParent', 'IAmNotBessedAndNotAnArray');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product)
        ,'IAmNotBessedAndNotAnArray'
        ,'correct with de_DE');

    $TestExporterObject->SetLocale('en_GB');
    $Product->setValue( 'getWithParent', $Product);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product),$Answer,'correct with en_GB');
    $Product->setValue( 'getWithParent', []);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product),$False,'correct with en_GB');
    $Product->setValue( 'getWithParent', 'IAmNotBessedAndNotAnArray');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product)
        ,'IAmNotBessedAndNotAnArray'
        ,'correct with en_GB');

    $TestExporterObject->SetLocale('fr_FR');
    $Product->setValue( 'getWithParent', $Product);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product),$Answer,'correct with fr_FR');
    $Product->setValue( 'getWithParent', []);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product),$False,'correct with fr_FR');
    $Product->setValue( 'getWithParent', 'IAmNotBessedAndNotAnArray');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product)
        ,'IAmNotBessedAndNotAnArray'
        ,'correct with fr_FR');

    # if not de or us it should return ''
    $TestExporterObject->SetLocale('xx_XX');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::material($TestExporterObject,$Product),$False,'correct with xx_XX');
}

sub testpattern{
    note ('--------------------------------------------------');
    note('test pattern');
    note ('--------------------------------------------------');
    # init
    my $False = '';
    my $Answer = 'TestResponse';
    my $Product = DE_EPAGES::GoogleBase::t::MockProduct->new();
    my $TestExporterObject = DE_EPAGES::GoogleBase::t::MockingExporterObject->new();
    $Product->setValue( 'Class', $Product );
    $Product->setValue( 'Alias', $Answer );

    # tests
    $TestExporterObject->SetLocale('en_US');
    $Product->setValue( 'getWithParent', $Product);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product),$Answer,'correct with en_US');
    $Product->setValue( 'getWithParent', []);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product),$False,'correct with en_US');
    $Product->setValue( 'getWithParent', 'IAmNotBessedAndNotAnArray');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product)
        ,'IAmNotBessedAndNotAnArray'
        ,'correct with en_US');

    $TestExporterObject->SetLocale('de_DE');
    $Product->setValue( 'getWithParent', $Product);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product),$Answer,'correct with de_DE');
    $Product->setValue( 'getWithParent', []);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product),$False,'correct with de_DE');
    $Product->setValue( 'getWithParent', 'IAmNotBessedAndNotAnArray');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product)
        ,'IAmNotBessedAndNotAnArray'
        ,'correct with de_DE');

    $TestExporterObject->SetLocale('en_GB');
    $Product->setValue( 'getWithParent', $Product);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product),$Answer,'correct with en_GB');
    $Product->setValue( 'getWithParent', []);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product),$False,'correct with en_GB');
    $Product->setValue( 'getWithParent', 'IAmNotBessedAndNotAnArray');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product)
        ,'IAmNotBessedAndNotAnArray'
        ,'correct with en_GB');

    $TestExporterObject->SetLocale('fr_FR');
    $Product->setValue( 'getWithParent', $Product);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product),$Answer,'correct with fr_FR');
    $Product->setValue( 'getWithParent', []);
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product),$False,'correct with fr_FR');
    $Product->setValue( 'getWithParent', 'IAmNotBessedAndNotAnArray');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product)
        ,'IAmNotBessedAndNotAnArray'
        ,'correct with fr_FR');

    # if not de or us it should return ''
    $TestExporterObject->SetLocale('xx_XX');
    is (DE_EPAGES::GoogleBase::API::CSV::GoogleBaseProductsExportDriver::pattern($TestExporterObject,$Product),$False,'correct with xx_XX');
}

RunScript( Sub => \&Main );